// Параллельные вычисления

function parallel(promises, callback) {
    const result = [];

    let done = 0;
    const setResult = (i, res) => {
        done++;
        result[i] = res;
        if (done === promises.length) {
            callback(result);
        }
    }

    for (let i in promises) {
        const promise = promises[i];
        const res = promise((res) => setResult(i, res));
        if (res) {
            setResult(i, res);
        }
    }
}

parallel([
	function (resolve) {
		setTimeout(function () {
			resolve(10);
		}, 50);
	},
	function () {
		return 5;
	},
	function (resolve) {
		setTimeout(function () {
			resolve(0);
		}, 10)
	}
], function (results) {
	console.log(results); // [10, 5, 0]
});
